/***************************************************************************
                          configdirectives.h  -  description
                             -------------------
    begin                : ?  9? 13 2003
    copyright            : (C) 2003 by Sheldon Lee Wen
    email                : leewsb@hotmail.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef CONFIGDIRECTIVES_H
#define CONFIGDIRECTIVES_H
#include <map>
#include <string>

/**This class contains a map of the global configuration directives from the users config file.
	*It is used to initialize the LConfig object. I'm encapsulating it b/c I may change it at a
	*later point. I haven't decided.
  *@author Sheldon Lee Wen
  */
using namespace std;

class ConfigDirectives {
public: 
	ConfigDirectives();
	~ConfigDirectives();
	string getValue(string key);
	int getValue(int key);
	void addValue(string key, string value);
	void addValue(int key, int value);
	void addValue(string key, int value);
	int getIntValue(string key);
	void clear() { directives.clear(); int_directives.clear(); si_directives.clear(); }
	string operator[](string key);
	int operator[](int key);
private:
	map<string,string> directives;
	map<int,int> int_directives;
	map<string,int> si_directives;
};

#endif
