/***************************************************************************
                          configloader.h  -  description
                             -------------------
    begin                : Sun Jan 5 2003
    copyright            : (C) 2003 by Sheldon Lee Wen
    email                : leewsb@hotmail.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#ifndef CONFIGLOADER_H
#define CONFIGLOADER_H

#ifdef HAVE_CONFIG_H
#include "../config.h"
#endif

#include "lconfig.h"
#include "loader.h"
#include "definitions.h"

class ConfigLoader : public Loader{

public:
	ConfigLoader();
	ConfigLoader(string filename);
    virtual ~ConfigLoader();
    /** Load a user config file */
    LConfig loadConfig();
  	/** Load the config for the file filename */
  	LConfig loadConfig(string filename);
private:
   map<const string, string>* processSingle(Vector* rawData);
  	/** Load the parsed information and return a config object. */
  	LConfig* getConfObj(map<const string,string> *results);
   
};
LConfig & operator>>(ConfigLoader &ldr, LConfig &lconf);
#endif

 
