/***************************************************************************
                          definitions.h  -  description
                             -------------------
    begin                : Sun Jan 5 2003
    copyright            : (C) 2003 by Sheldon Lee Wen
    email                : leewsb@hotmail.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#ifndef DEFINITIONS_H
#define DEFINITIONS_H

#ifdef HAVE_CONFIG_H
#  include "../config.h"
#endif

#include <string>
#include <map>
#include <vector>

#ifdef HAVE_XOSD
#  include <xosd.h>
#  include <sys/time.h>
#endif

//extern int mkdir(); /* in linux/fs.h ... other platforms!? */
using namespace std;

class LCommand;

typedef map<const string, LCommand> Hashtable;
typedef Hashtable::const_iterator HashIter;
typedef vector<string> Vector;
typedef Vector::const_iterator VecIter;

#define null  "_null_"
#define pnull 0
#define MAXRETRIES 25 /* prevents possible race condition, don't set this too low!! 25 will do */


#define CONF_HEADER \
"# LinEAK - Linux support for Easy Access and Internet Keyboards\n" \
"#  Copyright (c) 2001,2002, 2003  Sheldon Lee Wen <leewsb@hotmail.com>\n" \
"#  	and Mark Smulders <Mark@PIRnet.nl>\n" \
"#  http://lineak.sourceforge.net\n" \
"#\n" \
"# lineakd configuration file\n" \
"#\n" \
"# example key configuration:\n" \
"# \tplay\t= \"xmms --play-pause\"\n" \
"# \teject\t= EAK_EJECT\n" \
"#\n" \
"# available special actions:\n" \
"# \tEAK_EJECT\n" \
"# \tEAK_VOLUP\n" \
"# \tEAK_VOLDOWN\n" \
"# \tEAK_MUTE\n" \
"# \tEAK_SLEEP\n" \
"#\n" \
"\n"

#define DEF_HEADER \
"# LinEAK - Linux support for Easy Access and Internet Keyboards\n" \
"#  Copyright (c) 2001,2002, 2003 Sheldon Lee Wen <leewsb@hotmail.com>\n" \
"# 	and Mark Smulders <Mark@PIRnet.nl>\n" \
"#  http://lineak.sourceforge.net\n" \
"#\n" \
"# keyboard definition file:\n" \
"#   this file defines the extra keys of the keyboard types,\n" \
"#   and the corresponding keycode.\n" \
"#\n" \
"# if your keyboard is not in here, please send me an e-mail so\n" \
"# I can add support for it.\n" \
"#\n" \
"# WARNING: this definition file is NOT compatible with\n" \
"#          lineakd 0.1 and 0.2\n" \
"#          lineakconfig 0.1\n" \
"\n"


/* special actions in .conf file */
#define NR_SPECIALS 5
/* link them to strings */
#define EAK_EJECT "EAK_EJECT"
#define EAK_VOLUP "EAK_VOLUP"
#define EAK_VOLDOWN "EAK_VOLDOWN"
#define EAK_MUTE "EAK_MUTE"
#define EAK_SLEEP "EAK_SLEEP"
#define EAK_SCREEN_LOCK "EAK_SCREEN_LOCK"

/* the conf and def filenames */
/* A System wide config file */
#define SYS_CONFFILE "/etc/lineak/lineakd.conf"
#define LINEAKDIR "/.lineak/"
#define PICSDIR "/.lineak/Pics/"
#define CONFFILE "/.lineak/lineakd.conf" /* (relative from $HOME dir) */
#define BAKFILE "/.lineak/.lineakd.conf.backup"
#define DEFFILE  "lineakkb.def"
#define PIDFILE "/.lineak/lineakd.pid"


#define DEFAULT_CDROM_DEVICE "/dev/cdrom"
#define DEFAULT_MIXER_DEVICE "/dev/mixer";

/* for volume settings using the mixer device */
#define MIXERDEV DEFAULT_MIXER_DEVICE
#define VOLUP_VALUE 5
#define VOLDOWN_VALUE -5
#define VOLMUTE_VALUE 0
#define MAX_VOLUME 100

#define MAXRETRIES 25 /* prevents possible race condition, don't set this too low!! 25 will do */

/* Message Queue definitions */
#define CMDSIZE 5
#define ARGSIZE 200
#define LINKEY 291

#define HUP 1
//#define RELOAD 2
#define EXIT 3
#define TERM 15

#ifdef HAVE_XOSD
	#define XOSD_FONT      "-adobe-helvetica-bold-r-normal-*-*-240-*-*-p-*-*-*"
	#define XOSD_COLOR   "0aff00"
	#define XOSD_POS        XOSD_bottom
	#define XOSD_ALIGN    XOSD_center
    #define XOSD_HOFFSET    0
    #define XOSD_VOFFSET    50
    #define XOSD_TIMEOUT   3
    #define XOSD_SOFFSET    1
#endif

struct eak_direct_t {
//	char command[CMDSIZE];
	char args[ARGSIZE];
//	string command;
//	string args;
};

struct eak_msg {
	long int msg_type;
	eak_direct_t directive;
};
#endif
