/***************************************************************************
                          defloader.cpp  -  description
                             -------------------
    begin                : Sun Jan 26 2003
    copyright            : (C) 2003 by Sheldon Lee Wen
    email                : leewsb@hotmail.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#include "defloader.h"

#include "functions.h"
#include "ldef.h"
#include "lkbd.h"
#include "lkey.h"

using namespace lineak_util_functions;

DefLoader::DefLoader() {
}
DefLoader::DefLoader(string filename) : Loader(filename) {
}
DefLoader::~DefLoader(){
}
/** Process a file with sub sections */
Vector* DefLoader::processMulti(Vector* rawData) {
        if (rawData->empty())
    		return rawData;

       Vector *parsedData = new Vector;
       string tmpStore = null;
       string key=null;
       string data=null;
       for(unsigned int i = 0; i < rawData->size(); i++) {
          	tmpStore = (*rawData)[i];
            data = strip_space(tmpStore);
            parsedData->push_back(data);
       }
      delete (rawData);
      return parsedData;
}
/** Load a keyboard definition file */
LDef DefLoader::loadDef() {
      LDef def(file);
      def.setTable(*(getDefObj(processMulti(loadFile()))));
      return def;
}
/** Load the config for the file filename */
LDef DefLoader::loadDef(string filename) {
    LDef tmp;
	if ( setFile(filename) )
		return (loadDef());
	return	 tmp;
}

/** Return a keyboard definition object. */
/** We take out the standard heading from the map,
	brandname, modelname and the keyboard name.
	Then everything that is left should be key definitions.
	We then add those keys to the keyboard object */
LKbdtable* DefLoader::getDefObj(Vector *results){
	LKbdtable *deftable = new LKbdtable();
	// Initialize the table.
	deftable->clear();
    // If we don't have any values loaded. Return empty keyboard table.
    if (results == pnull )
    	return deftable;
    if (results->empty()) {
		delete (results);
		return deftable;
	}

	LKbd *def = new LKbd();
	string tmp,tmp2,tmp3=null, heading = null;
 	string key=null,data=null;
	int loc;

	for (unsigned int i=0; i < results->size(); i++) {
        tmp = (*results)[i];
        if ( tmp.find('[') != string::npos && tmp.find(']') != string::npos ) {
        	// The Keyboard Name
			if ( tmp.find("KEY") == string::npos && tmp.find("END") == string::npos )
				def->name = strip_space(tmp.substr(1,tmp.size()-2));
				/** create a new keyboard object */
			// End of Keyboard Definition Marker
			if ( tmp.find("KEY") == string::npos && tmp.find("END") != string::npos ) {
				heading = "END";
				/**  set heading = null;
						add the keyboard config object to a map<string,LKbd>
				        create a new keyboard config object to add to */
				        heading = null;
				        (*deftable)[def->name]= def;
				        def = new LKbd();
			}
			// Beginning of KEYS section
			if ( tmp.find("KEY") != string::npos && tmp.find("END") == string::npos )
				heading = "KEYS";
			// End of KEYS section
			if ( tmp.find("KEY") != string::npos && tmp.find("END") != string::npos ) {
				heading = "END KEYS";
				continue;
			}
		}
		else {
	        if ( heading == null ) {
        		// found a global entry
            	loc = tmp.find('=');
            	if (loc == 0) continue;
            	key = strip_space(tmp.substr(0,loc));
            	data = strip_space(tmp.substr(loc+1, tmp.size()-(loc+1)));
            	if ( key == "brandname")
            		def->brand = data;
            	if ( key == "modelname")
             		def->model = data;
         	}
         	else {
         		// found a key entry
            	loc = tmp.find('=');
            	if (loc == 0) continue;
            	key = strip_space(tmp.substr(0,loc));
            	data = strip_space(tmp.substr(loc+1, tmp.size()-(loc+1)));
            	def->addKey(key, atoi(data.c_str()));
          	}
        }
	}
	// Initialize and fill in the values for the config object here.
	delete (results);
	return (deftable);
}

LDef & operator>>(DefLoader &ldr, LDef &ldef) {
	return (ldef = ldr.loadDef());
}
