/***************************************************************************
                          defloader.h  -  description
                             -------------------
    begin                : Sun Jan 26 2003
    copyright            : (C) 2003 by Sheldon Lee Wen
    email                : leewsb@hotmail.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef DEFLOADER_H
#define DEFLOADER_H

#ifdef HAVE_CONFIG_H
#include "../config.h"
#endif

#include "loader.h"
//#include "lkbd.h"
//#include "ldef.h"
class LDef;
class LKbd;

typedef map<string,LKbd*> LKbdtable;
typedef LKbdtable::const_iterator LKbdIter;

//#include "definitions.h"

/**Loads keyboard definition files.
  *@author Sheldon Lee Wen
  */

class DefLoader : public Loader  {
public: 
	DefLoader();
	DefLoader(string filename);
	virtual ~DefLoader();

	  /** Load a keyboard definition file */
    LDef loadDef();
  	/** Load the config for the file filename */
  	LDef loadDef(string filename);
private:
   Vector* processMulti(Vector* rawData);
  	/** Return a keyboard definition object. */
  	LKbdtable* getDefObj(Vector *results);

};
LDef & operator>>(DefLoader &ldr, LDef &ldef);
#endif
