/***************************************************************************
                          ldef.cpp  -  description
                             -------------------
    begin                : Sun Jan 26 2003
    copyright            : (C) 2003 by Sheldon Lee Wen
    email                : leewsb@hotmail.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <iterator>
#include <algorithm>
#include "ldef.h"
#include "defloader.h"
#include "lconfigdata.h"
//#include "functions.h"

//using namespace lineak_util_functions;

LDef::LDef(){
	deffilename = null;
	table.clear();
}
LDef::LDef(string file) : deffilename(file) {
}

LDef::LDef(DefLoader &def){
	if (def.getFile() != null) {
    	setTable(def.loadDef().getTable());
     	setFilename(def.getFile());
    }
    else 
    	setFilename(null);
     	
}
LDef::~LDef(){
}
Vector LDef::getKeyboards() const {
	Vector result;
    for (LKbdIter m = table.begin(); m != table.end(); m++) {
		result.push_back(m->first);
	}
	return result;
}
Vector LDef::getBrands() const {
	Vector result;
    for (LKbdIter m = table.begin(); m != table.end(); m++) {
		result.push_back(m->second->brand);
	}
	sort(result.begin(),result.end());
	Vector ret(result.begin(), unique(result.begin(), result.end()));
	return ret;
}
Vector LDef::getModels() const {
	Vector result;
    for (LKbdIter m = table.begin(); m != table.end(); m++) {
		result.push_back(m->second->model);
	}
	sort(result.begin(),result.end());
	Vector ret(result.begin(), unique(result.begin(), result.end()));
	return ret;
}
LKbdtable LDef::getModels(string brand) {
    LKbdtable models;
    for (LKbdIter m = table.begin(); m != table.end(); m++) {
    	if (m->second->brand == brand)
     		models[m->first] = m->second;
    }
    return models;
}
LKbdtable& LDef::getTable() {
	return table;
}
LKbd& LDef::getKeyboard(string brand, string model) {

    for (LKbdIter m = table.begin(); m != table.end(); m++) {
    	if (m->second->brand == brand && m->second->model == model)
     		return *(m->second);
    }
    // If we can't find our keyboard, return a reference to our empty keyboard.
    blank.name = null;
    return (blank);
}
LKbd& LDef::getKeyboard(string name) {
    for (LKbdIter m = table.begin(); m != table.end(); m++) {
    	if (m->first == name)
     		return *(m->second);
    }
    // If we can't find our keyboard, return a reference to our empty keyboard.
    blank.name = null;
    return (blank);
}
bool LDef::hasKeyboard(string name) {
    for (LKbdIter m = table.begin(); m != table.end(); m++) {
    	if (m->first == name)
     		return true;
    }
   return false;
}

void LDef::setFilename(string file) {
	deffilename = file;
}
bool LDef::isEmpty() {
	return (table.empty() || (deffilename == null));
}
void LDef::print(ostream &out) const {
    out << DEF_HEADER;
    out << endl;
    for (LKbdIter m = table.begin(); m != table.end(); m++) {
    	out << *(m->second);
    }
}
void LDef::addKeyboard(LKbd &newkb) {
    // Add a keyboard.
	table[newkb.name] = &newkb;

}
void LDef::addKeyboards(LDef &newdef) {
    LKbdtable &tmp = newdef.getTable();
    for (LKbdIter m = tmp.begin(); m != tmp.end(); m++) {
    	// Add a keyboard.
		table[m->first] = m->second;
    }
}
