/***************************************************************************
                          loader.cpp  -  description
                             -------------------
    begin                : Sun Jan 26 2003
    copyright            : (C) 2003 by Sheldon Lee Wen
    email                : leewsb@hotmail.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <fstream>
#include <iostream>
#include <iomanip>
#include <sstream>
#include <string>
#include <stdlib.h>
#include "functions.h"

using namespace lineak_util_functions;

#include "loader.h"

Loader::Loader(string filename) : file(filename) {
}
Loader::~Loader(){
}
/** Attempt to open a file, and put all of it's lines in a vector
	Return a null pointer if unsuccessful */
Vector* Loader::loadFile() {
      char buffer[500] = {0};
      string tmpStore = null;
      string seperators = " \n\t";
      Vector *tmpResults;

      ifstream in(file.c_str());
      if (!in.is_open()) {
      	cerr << endl << "Failed to open file " << file << " for a load operation" << endl;;
       	in.clear();
        in.close(); //for good measure.
      	return (new Vector);
      }

      tmpResults = new Vector;
      unsigned int  index = 0;
     	while(!in.eof()) {
        	in.getline(buffer, 500, '\n');
         	tmpStore = string(buffer);
            // If there is a '#' in the line somwhere...... start looking at the end of the line.
            if(tmpStore.rfind('#') != string::npos) {
//            if(tmpStore.find('#') != string::npos)
                index = tmpStore.rfind('#');
                // Determine if there is a comment at the end of the line, or an escaped '#' that is part of the command.
                  // If we have a '#' that is not escaped.
                while (index != 0) {
                  // If the previous character is not an escape
                  if (index > 0 &&  tmpStore[index -1] != '\\')
                    // get out of this loop
                    break; // index = string::npos
                  else
                    /** The previous character is an escape and the index
                          is at least one. Which means that at least we have '\#' on the line. */
                    if (index > 0)
                      index = tmpStore.rfind('#',index-1);
                    // We shouldn't get here.
                    else {
                      cerr << "Shouldn't be here" << endl;
                      break;
                    }
                }
            	tmpStore = tmpStore.substr(0, index);
            }
            if (tmpStore.length()<=0 || tmpStore.find_first_not_of(seperators) == string::npos) continue;
			// tmp store now has a line of input from the config file.
			tmpResults->push_back(tmpStore);
         }
         in.close();
         in.clear();
//         cout << "here is what we have\n";
//         inspect_vector(*tmpResults);
		return (tmpResults);
}
/** Set the filename of the configloader */
bool Loader::setFile(const string filename){
	if ( file_exists(filename)) {
		file = filename;
		return true;
	}
	return false;
}
