/***************************************************************************
                          msgpasser.cpp  -  description
                             -------------------
    begin                : Sun Feb 23 2003
    copyright            : (C) 2003 by Sheldon Lee Wen
    email                : leewsb@hotmail.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "msgpasser.h"
#include <string>
#include <iostream>
#include "cmdprefs.h"
#include "definitions.h"

extern CmdPrefs cmdprefs;
using namespace std;
bool msgPasser::running = true;
bool verbose = cmdprefs.getVerbose();

msgPasser::msgPasser(){
	msg_to_recieve = 0;
	failed = false;
//	key = LINKEY + getuid();
    string pathname= getenv("HOME");
    pathname += LINEAKDIR;
    key = ftok(pathname.c_str(), LINKEY);
    if (key == -1) {
    	cerr << "Failed to generate a System V IPC key." << endl;
     }
     else
     	key = LINKEY + getuid();
	start();
}

msgPasser::~msgPasser(){
}
bool msgPasser::start() {
	msgid = msgget((key_t)key, 0640 | IPC_CREAT);
	if (msgid == -1) {
		cerr << "Failed to set up message queue with error: " << errno << endl;
		failed = true;
	}
	return (failed);
}
void msgPasser::quit() {
	if (msgid != -1) {
		if (msgctl (msgid, IPC_RMID, 0) == -1) {
			cerr << "msgctl(IPC_RMID) failed" << endl;
		}
	}
	msgid = -1;
}
eak_msg msgPasser::getMessage() {
	myMsg.msg_type = 0;
	strcpy(myMsg.directive.args,"");
	if (msgrcv(msgid, (void *)&myMsg, sizeof(eak_direct_t), msg_to_recieve, IPC_NOWAIT) == -1 )
		if (verbose) cerr << "msgrcv failed with error: " << errno << endl;

	return myMsg;
}
void msgPasser::sendMessage(int comm, string args) {
	myMsg.msg_type = comm;
	
	strcpy(myMsg.directive.args, args.c_str());
	if (msgsnd(msgid, (void *)&myMsg, sizeof(eak_direct_t), IPC_NOWAIT) == -1) 
		if (verbose) cerr << "msgsnd failed" << endl;
		
}
