/***************************************************************************
                          msgpasser.h  -  description
                             -------------------
    begin                : Sun Feb 23 2003
    copyright            : (C) 2003 by Sheldon Lee Wen
    email                : leewsb@hotmail.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef MSGPASSER_H
#define MSGPASSER_H

extern "C" {
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <errno.h>
#include <unistd.h>
#include <pwd.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
}
#include "definitions.h"

/**Pass messages via a message queue.
  *@author Sheldon Lee Wen
  */

class msgPasser {
public: 
	msgPasser();
	~msgPasser();
	/** Get a message from the queue */
	eak_msg getMessage();
	/** Send a message to the message queue */
	void sendMessage(int comm, string args);
	/** Remove the message queue. */
	void quit();
	/** Create the message queue */
	bool start();
private:
	static bool running;
	bool failed;
	int msgid;
	struct eak_msg myMsg;
	long int msg_to_recieve;
//	uid_t key;
	key_t key;
	
	
};

#endif
