/***************************************************************************
                          xmgr.h  -  description
                             -------------------
    begin                : Tue Feb 18 2003
    copyright            : (C) 2003 by Sheldon Lee Wen
    email                : leewsb@hotmail.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef XMGR_H
#define XMGR_H

/* settings from configure */
#ifdef HAVE_CONFIG_H
#  include "../config.h"
#endif

//#include <sys/types.h>
//#include <sys/stat.h>

extern "C" {
#include <stdio.h>
#include <X11/X.h>
#include <X11/Xlib.h>
#include <X11/Xos.h>
#include <X11/Xutil.h>
#include <X11/Xatom.h>
#include <X11/XKBlib.h>
#include <X11/extensions/XKBfile.h>
//#include <X11/extensions/shape.h>

}

#include <string>
#include <iostream>

#include "definitions.h"

class LKbd;

/**Manager initializing and restoring X configurations.
  *@author Sheldon Lee Wen
  */

class Xmgr {
public: 
	Xmgr(string display = null);
	~Xmgr();
	Display* openDisplay(string &dpyName, int &opcodeRtrn, int &evBaseRtrn);
  Display* getDisplay() { return ourdisplay; }
  void xkbRemapped(bool value) { xkbremapped = true; }
  bool xkbRemapped() { return xkbremapped; }
	void initialize(LKbd& myKbd);
  void cleanup(LKbd& myKbd);
  int xkbEventCode() { return EventCode; }

private:
	static int dummyAfterFunc(Display* theDisplay) { return 0; }
  static int Xhandler(Display* theDisplay, XErrorEvent* xev);
  void commitXKBChanges(int tcode);
	
	Display *ourdisplay;
	XkbDescPtr xkb,xkb_backup;
	string displayname;
	int xkbOpcode;
	int EventCode;

	static bool xkbremapped;
	static bool caughtXerror;
	static int nrretries;
	static bool got_xkb;
};

#endif
